package tools.descartes.prisma.agent.wildfly.callstack;

import java.util.Collection;
import java.util.Collections;

public abstract class InvocationGroupRecord {
	
	private final TraceFactory factory;
	private final OperationRecord operation;
	private final String name;
		
	public InvocationGroupRecord(OperationRecord operation, String name) {
		this.operation = operation;
		this.name = name;
		factory = operation.getTraceFactory();
	}
	
	public String getName() {
		return name;
	}

	public long getInvocationCount() {
		return 0;
	}
	
	public long getExecutionTime() {
		return 0;
	}
	
	public OperationRecord getOperation() {
		return operation;
	}
	
	public String getAdditionalInformation() {
		return "";
	}
	
	public TraceFactory getTraceFactory() {
		return factory;
	}
	
	public void addInvocation(long timeInNanos, long cpuTimeInNanos, long beforeCpuTimeInNanos) {
	}
	
	public abstract ComponentRecord requireComponent(String component);
	
	public abstract boolean isFiltered();
	
	public abstract void accept(TraceVisitor visitor, InvocationGroupRecord source);
	
	public Collection<ComponentRecord> getRequiredComponents() {
		return Collections.emptyList();
	}		
}
