package tools.descartes.prisma.agent.wildfly.interceptors.jms;

import java.util.Deque;

import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Queue;
import javax.jms.Topic;

import tools.descartes.prisma.agent.wildfly.callstack.ComponentRecord;
import tools.descartes.prisma.agent.wildfly.callstack.InterfaceRecord;
import tools.descartes.prisma.agent.wildfly.callstack.InvocationGroupRecord;
import tools.descartes.prisma.agent.wildfly.callstack.OperationRecord;
import tools.descartes.prisma.agent.wildfly.callstack.ThreadCallStack;

public class MessageInterceptor {
	
	public static void intercept(Destination destination) {
		Deque<InvocationGroupRecord> threadCallStack = ThreadCallStack.get();
		InvocationGroupRecord currentOperation = threadCallStack.peek();
		if (currentOperation != null) {		
			String destinationName = null;
			String componentClass = null;
			try {
				if (destination instanceof Queue) {
					destinationName = ((Queue)destination).getQueueName();
					componentClass = "javax.jms.Queue";
				} else if (destination instanceof Topic) {
					destinationName = ((Topic)destination).getTopicName();
					componentClass = "javax.jms.Topic";
				}
				if (destinationName != null) {
					ComponentRecord crec = currentOperation.requireComponent(destinationName);
					if (crec.getComponentClass() == null) {
						crec.setComponentClass(componentClass);
					}
					InterfaceRecord irec = crec.requireInterface("javax.jms.MessageProducer");
					OperationRecord orec = irec.requireOperation("send");
					InvocationGroupRecord grec = orec.requireInvocationGroup(0);
					grec.addInvocation(0, 0, 0);
				}
			} catch (JMSException e) {
				e.printStackTrace();
			}
		} else {
			System.err.println("NO OPERATION FOUND!!!!!!");
		}
	}
}
